pub struct Defer {
    f: Box<dyn Fn()>,
}

impl Defer {
    pub fn new<F: Fn() + 'static>(f: F) -> Self {
        Self { f: Box::new(f) }
    }
}

impl Drop for Defer {
    fn drop(&mut self) {
        log::debug!("Calling defer function");
        self.f.as_ref()();
    }
}
